#include <stdio.h>
#include <math.h>
#define BYTE  unsigned char    
int wlen=2000;                 // cut_pic width
int hlen=3100;                 // cut_pic height

#define nn  3600*5100             // max pic size,iW*iH
BYTE b[nn];                       // raw & result map
BYTE a[nn];                       // temporary work map
int  iW,iH,iColorType;            // width, height, 256/16m_color
short h[539];                     // BMP header
double a1,a2,a3,a4,a5,a6;         // 6 transfer parms
int  it;                          // print more 

double angle;                     // given or calculate: cut_pic turn around
int  xc,yc;                       // given or calculate: cut_pic center pixel 

int  bmp2raw(char *f1,BYTE *b);
void rot(BYTE *b,int iW,int iH,double angle);
void cut(BYTE *b,int *iW,int *iH,int xc,int yc);
void raw2bmp(char *f2,BYTE *b);

main(int ac,char **av)
{
  char f1[22],f2[24]; int i;
  if(ac<2){ printf("\n\t ****** cut of BMP(256) *******\n");
            printf("\n\t                       jiang, 2013,12,04\n");
            printf("\n\t sl20 in[.bmp] [angle xc yc !]");
            printf("\n\t Usage: sl11 page1 -1.2");
            printf("\n\t set output bmp file:  s_in.bmp  %d*%d",wlen,hlen);
            printf("\n\t angle: in degree");
            printf("\n\t xc yc: cut_pic center"); 
            printf("\n\t ! means: print more\n\n");
            return(0); }
  if(av[1][0]=='!'){
            printf("\n\t sl20 p1 0.5 1000 2200");
            printf("\n\t sl20 p2 1.2 1000 2200");
            printf("\n\t sl20 p3 0.0 1000 2150");
            printf("\n\t sl20 p4 2.0 1000 2150");
            printf("\n\t sl20 p5 -1. 1000 2150");
            printf("\n\t sl20 page0 -2.3 1600 2150");
            printf("\n\t sl20 page1 -1.5 1000 3100");
            printf("\n\t sl20 page2 -1.0 1000 2950");
            printf("\n\t sl20 page3 -1.5 1100 2950");
            printf("\n\t sl20 page4  1.5 1000 2950");
            printf("\n\t sl20 page5  2.8 1500 2700");
            printf("\n\t sl20 page6  2.0 1180 1750");
            printf("\n\t sl20 page7  2.0 1150 1950");
            printf("\n\t sl20 page8  0.0 1150 3350");
            printf("\n\t sl20 page9  3.5 1580 1950");
            printf("\n"); return(0); }
  it=(ac>5)?1:0; strcpy(f1,av[1]);
  for(i=0;i<strlen(f1);i++)if(f1[i]=='.')break; f1[i]=0; strcat(f1,".bmp");
  angle=99; if(ac>2)sscanf(av[2],"%lf",&angle);
  xc=yc=-1; if(ac>3)sscanf(av[3],"%d",&xc); 
            if(ac>4)sscanf(av[4],"%d",&yc); 

  i=bmp2raw(f1,b);
  if(i==1){ printf("\n\t%s not found!\n",f1); return(0); }
  if(i==2){ printf("\n\t%s color map not support !\n",f1); return(0); }
  if(iW<wlen)wlen=iW;  if(iH<hlen)hlen=iH;

  if(angle==99.)angle=0.;
  rot(b,iW,iH,angle);

  if(xc==-1)xc=iW/2; if(yc==-1)yc=iH/2;
  cut(b,iW,iH,xc,yc);

  iW=wlen; iH=hlen;
  sprintf(f2,"s_%s",f1); printf(" ok ! outfile: %s\n",f2);
  raw2bmp(f2,b);

  return(0);
}

int bmp2raw(char *f1,BYTE *b)
{
  int i,j,k; FILE *fp; BYTE *p1;         
  fp=fopen(f1,"rb"); if(!fp)return(1); printf("%s ==> ",f1);
  fread(h,2,27,fp);  iColorType=h[14]/8;  iW=h[9]; iH=h[11]; 
  if(it)printf("iW:%6d\tiH:%6d\tcolor: %d\n",iW,iH,iColorType);
  if(iColorType==3)return(2);
  k=(4-iW%4)%4+iW; fread(&h[27],2,512,fp);
  for(j=0;j<iH;j++){ p1=(BYTE *)b+j*iW; fread(p1,1,k,fp); }
  fclose(fp);
  return(0);
}

void rot(BYTE *b,int iW,int iH,double angle)
{
  int i,j,k, ix,iy,u,v;
  double cosa,sina,z;
  float x,y, wx,wy,ux,uy, z0,z1,z2,z3;
  BYTE *p0,*p1;              
  z=angle*3.1416/180.;
  cosa=cos(z); sina=sin(z);
  a1=a4=cosa; a2=sina;  a3=-a2; a5=iW/2; a6=iH/2;

  p0=(BYTE *)b; p1=(BYTE *)a;
  for(j=0;j<iH;j++)for(i=0;i<iW;i++){
    x=a1*(i-a5)+a3*(j-a6)+a5; y=a2*(i-a5)+a4*(j-a6)+a6;
    ix=x; wx=x-ix; ux=1.-wx; iy=y; wy=y-iy; uy=1.-wy;
    if(ix<0 || ix>=iW-2 || iy<0 || iy >=iH-2){ *p1++=255; continue; }
    u=iW*iy+ix; v=u+iW;
    if(u>=0 && v<iW*iH-1){
      z0=ux*uy; z1=wx*uy; z2=ux*wy; z3=wx*wy;
      *p1++=p0[u]*z0+p0[u+1]*z1+p0[v]*z2+p0[v+1]*z3;
    } else *p1++=255;
  }
  p0=(BYTE *)b; p1=(BYTE *)a; for(i=0;i<iW*iH;i++)*p0++=*p1++;
}

void cut(char *b,int iW,int iH,int xc,int yc)
{
  int i,j,i1,i2,j1,j2; BYTE *p0,*p1;
  p0=(BYTE *)b; p1=(BYTE *)a; for(i=0;i<iW*iH;i++)*p1++=*p0++;  // may ignore
  i1=xc-wlen/2; i2=xc+wlen/2; 
  if(i1<0){ i2-=i1;  i1=0; } if(i2>=iW){ i1-=i2-iW; i2=iW; }    
  j1=yc-hlen/2; j2=yc+hlen/2; 
  if(j1<0){ j2-=j1;  j1=0; } if(j2>=iH){ j1-=j2-iH; j2=iH; }    
  p0=(BYTE *)b; for(j=j1;j<j2;j++)for(i=i1;i<i2;i++)*p0++=a[j*iW+i];
}

void raw2bmp(char *f2,BYTE *b)
{
  int i,j,k;  FILE *fp; BYTE *p1;   
  h[9]=iW; h[11]=iH;
  fp=fopen(f2,"wb"); k=(4-iW%4)%4+iW; fwrite(h,2,539,fp);
  for(j=0;j<iH;j++){ p1=(BYTE *)b+j*iW; fwrite(p1,1,k,fp); } fclose(fp);
}

tofit(f1,a,n1,n2)
char *f1; BYTE *a; int n1,n2;
{
  int i,j; FILE *fp; char head[36][80];
  for(j=0;j<36;j++)for(i=0;i<80;i++)head[j][i]=32;
  sprintf(head[ 0],"SIMPLE  =                    T /");
  sprintf(head[ 1],"BITPIX  =                    8 /");
  sprintf(head[ 2],"NAXIS   =                    2 /");
  sprintf(head[ 3],"NAXIS1  =                 %4d /",n1);
  sprintf(head[ 4],"NAXIS2  =                 %4d /",n2);
  sprintf(head[35],"END                             ");
  for(j=0;j<36;j++)head[j][32]=32;
  fp=fopen(f1,"wb");  fwrite(head,36,80,fp);
  fwrite(a,n1,n2,fp); fclose(fp);
  printf("%s produced !\n",f1);
}
